-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
local MagnetNode
local MagnetNodeId
local WorldNodePos
local carID
local MagnetStatus

local MagnetArcade
local MagnetPermanent
local MagnetForce
local carID

-- Every frame update
local function updateGFX(dt)
    if MagnetPermanent == true then
        MagnetWorldPos = obj:getPosition() + obj:getNodePosition(MagnetNodeId)
        BeamEngine:queueAllObjectLuaExcept(string.format("extensionMagnet.receiveMagnetPosition(%s, %s, %s, %s)", tostring(MagnetWorldPos), tostring(carID), tostring(MagnetNodeId), tostring(dt), tostring(MagnetForce)), carID)
    else
        extensions.ui_simplePowertrainControl.setButton("powertrain_device_mode_shortcut_" .. MagnetNode, "Magnet Control", "tech_magnetonsurface", nil, nil, "electrics.values.MagnetInput = 1 - (electrics.values.MagnetInput or 0)")
        if electrics.values.MagnetInput == 1 then
            MagnetWorldPos = obj:getPosition() + obj:getNodePosition(MagnetNodeId)
            BeamEngine:queueAllObjectLuaExcept(string.format("extensionMagnet.receiveMagnetPosition(%s, %s, %s, %s)", tostring(MagnetWorldPos), tostring(carID), tostring(MagnetNodeId), tostring(dt), tostring(MagnetForce)), carID)
        end
    end
end

-- Every reset update
local function reset(jbeamData)
    print("magnet controller reset!")
    electrics.values.MagnetInput = 0
end

-- Every init update
local function init(jbeamData)
    print("magnet controller initialized!")
    electrics.values.MagnetInput = 0
    MagnetNode = jbeamData.node
    MagnetPermanent = jbeamData.permanent or false
    MagnetArcade = jbeamData.arcade or true
    MagnetForce = jbeamData.force or 1000
    carID = obj:getId()
    print(MagnetNode)
    MagnetNodeId = beamstate.nodeNameMap[jbeamData.node] or 9999
    print(MagnetNodeId)
    if MagnetNodeId == 9999 then
        log("E", "controllerMagnet", "Invalid Magnet node, node set to: "..dumps(jbeamData.node))
        M.updateGFX = nop
    end
end


M.init = init
M.reset = reset
M.updateGFX = updateGFX
return M