local M = {}
local min = math.min

local function receive(MagnetPos, MagnetCar, MagnetNodeId, delta)
    --gcprobe()
    --timeprobe()
    local carPos = obj:getPosition()
    local carID = obj:getId()
    local totalDistance = carPos:distance(MagnetPos)
    --print(MagnetPos, MagnetCar)
    local totalForce = vec3(0, 0, 0)
    if totalDistance <= 25 then
        for cid, node in pairs(v.data.nodes) do
            if node.nodeMaterial == 2 then
                local worldPos = carPos + obj:getNodePosition(cid)
                local distance = worldPos:distance(MagnetPos)
                local force = (node.nodeWeight * 100) / (distance * distance)
                local dir = MagnetPos - worldPos
                local forceVec = dir / dir:len() * min(force, 5000)

                -- dump(carID, worldPos, distance, force, forceVec)

                obj:applyForceVectorTime(cid, forceVec, delta)
                totalForce = totalForce - forceVec
            end
        end
        BeamEngine:queueAllObjectLua(string.format("extensionMagnet.receiveMagnetForce(%s, %s, %s, %s)", tostring(totalForce), tostring(MagnetCar), tostring(MagnetNodeId), tostring(delta)))
    end
    --gcprobe()
    --timeprobe()
end
local function force(totalForce, MagnetCar, MagnetNodeId, delta)
    local carID = obj:getId()
    if carID == MagnetCar then
        for cid, node in pairs(v.data.nodes) do
            if cid == MagnetNodeId then
                obj:applyForceVectorTime(MagnetNodeId, totalForce, delta)
            end
        end
    end
end
M.receiveMagnetPosition = receive
M.receiveMagnetForce = force
return M