-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['boom_rot'] = 0
  electrics.values['boom_rot_input'] = 0
end

local function updateGFX(dt) -- ms
  electrics.values['boom_rot'] = math.min(1, math.max(-1, (electrics.values['boom_rot'] + electrics.values['boom_rot_input'] * dt * 0.02)))
end

local function boom_rot(value)
  electrics.values.boom_rot_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.boom_rot = boom_rot

return M
