-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['boom_winch'] = 0
  electrics.values['boom_winch_input'] = 0
end

local function updateGFX(dt) -- ms
  electrics.values['boom_winch'] = math.min(1, math.max(0, (electrics.values['boom_winch'] + electrics.values['boom_winch_input'] * dt * 0.02)))
end

local function boom_winch(value)
  electrics.values.boom_winch_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.boom_winch = boom_winch

return M
